"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.replaceRefsToRef = void 0;
var t = _interopRequireWildcard(require("@babel/types"));
var _traverse = _interopRequireDefault(require("@babel/traverse"));
var _store = _interopRequireDefault(require("../store"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
// replace this.$refs to ref
var replaceRefsToRef = exports.replaceRefsToRef = function replaceRefsToRef(ast) {
  (0, _traverse["default"])(ast, {
    MemberExpression: function MemberExpression(path) {
      if (t.isMemberExpression(path.node.object) && t.isIdentifier(path.node.object.property, {
        name: '$refs'
      }) && t.isIdentifier(path.node.property)) {
        // replace this.$refs to ref
        var name = path.node.property.name;
        var ref = t.variableDeclaration('const', [t.variableDeclarator(t.identifier(name), t.callExpression(t.identifier('ref'), [t.nullLiteral()]))]);
        _store["default"].addBeforeSetupStatement(name, ref);
        _store["default"].addShortReturnStatementByName(name);
        _store["default"].addRef(name);
        var newExpression = t.memberExpression(t.identifier(name), t.identifier('value'));
        path.replaceWith(newExpression);
        return;
      }
    }
  });
};