"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wrapNewLineComment = exports.parseVueFromContent = exports.newLine = void 0;
var _compilerSfc = require("@vue/compiler-sfc");
var newLine = exports.newLine = 'REPLACE_FOR_NEW_LINE';
var parseVueFromContent = exports.parseVueFromContent = function parseVueFromContent(content) {
  var _parseVue = (0, _compilerSfc.parse)(content),
    descriptor = _parseVue.descriptor,
    errors = _parseVue.errors;
  if (errors.length > 0) {
    throw new Error(errors.join('\n'));
  }
  return descriptor;
};
var wrapNewLineComment = exports.wrapNewLineComment = function wrapNewLineComment(node) {
  if (!node) {
    return null;
  }
  node.leadingComments = [{
    type: 'CommentLine',
    value: newLine
  }];
  return node;
};