import * as t from '@babel/types';
import { NodePath } from '@babel/traverse';
import { ParseResult } from '@babel/parser';
export declare const getDefaultNode: (ast: ParseResult<t.File>) => NodePath<t.ExportDefaultDeclaration>;
export declare const getComponentName: (node: NodePath<t.ExportDefaultDeclaration>) => t.ObjectProperty;
export declare const getDecoratorArguments: (property: t.ClassProperty | t.ClassDeclaration) => (t.ArgumentPlaceholder | t.SpreadElement | t.Expression)[];
export declare const getBodyClass: (node: NodePath<t.ExportDefaultDeclaration>) => t.ClassBody;
export declare const isHasDecorator: (property: t.ClassProperty, decoratorName: string) => boolean;
export declare const getClassPropertiesByDecoratorName: (node: NodePath<t.ExportDefaultDeclaration>, decoratorName: string) => t.ClassProperty[];
export declare const createShortHandProperty: (name: string) => t.ObjectProperty;
