"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var monaco = _interopRequireWildcard(require("monaco-editor"));
var _editor = _interopRequireDefault(require("monaco-editor/esm/vs/editor/editor.worker?worker"));
var _json = _interopRequireDefault(require("monaco-editor/esm/vs/language/json/json.worker?worker"));
var _css = _interopRequireDefault(require("monaco-editor/esm/vs/language/css/css.worker?worker"));
var _html = _interopRequireDefault(require("monaco-editor/esm/vs/language/html/html.worker?worker"));
var _ts = _interopRequireDefault(require("monaco-editor/esm/vs/language/typescript/ts.worker?worker"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
// @ts-ignore

// @ts-ignore

// @ts-ignore

// @ts-ignore

// @ts-ignore

self.MonacoEnvironment = {
  getWorker: function getWorker(_, label) {
    if (label === 'json') {
      return new _json["default"]();
    }
    if (label === 'css' || label === 'scss' || label === 'less') {
      return new _css["default"]();
    }
    if (label === 'html' || label === 'handlebars' || label === 'razor') {
      return new _html["default"]();
    }
    if (label === 'typescript' || label === 'javascript') {
      return new _ts["default"]();
    }
    return new _editor["default"]();
  }
};
monaco.languages.typescript.typescriptDefaults.setEagerModelSync(true);